package cn.iocoder.yudao.framework.common.pojo;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Schema(description = "分页结果")
@Data
public final class PageResult<T> implements Serializable {

    @Schema(description = "数据", requiredMode = Schema.RequiredMode.REQUIRED)
    private List<T> list;

    @Schema(description = "总量", requiredMode = Schema.RequiredMode.REQUIRED)
    private Long total;
    @Schema(
            description = "当前页数据量",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    private Integer currentSize;
    @Schema(
            description = "当前页数",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    private Integer currentPage;


    public PageResult() {
    }

    public PageResult(List<T> list, Long total) {
        this.list = list;
        this.total = total;
    }

    public PageResult(Long total) {
        this.list = new ArrayList<>();
        this.total = total;
    }
    public PageResult(List<T> list, Long total, Integer currentSize, Integer currentPage) {
        this.list = list;
        this.total = total;
        this.currentPage = currentSize;
        this.currentSize = currentPage;
    }
    public static <T> PageResult<T> empty() {
        return new PageResult<>(0L);
    }

    public static <T> PageResult<T> empty(Long total) {
        return new PageResult<>(total);
    }

}
